function [JI,unmat,todmat] = FAC_jumpdetection(ReturnMat,n_per_day,ndays,deltan,alpha,plotflag)
[n,d] = size(ReturnMat);
unmat = zeros(n,d);
todmat = zeros(n_per_day,d);
for i = 1:d
    [JI,un,tod] = FAC_jumpdetection_vec(ReturnMat(:,i),n_per_day,ndays,deltan,alpha,plotflag);
    unmat(:,i) = un;
    todmat(:,i) = tod;
end


function [JI,un,tod] = FAC_jumpdetection_vec(ReturnVector,n_per_day,ndays,deltan,alpha,plotflag)
% Compute the TOD 
killindex = []; p = 2;
tod = FAC_tod(ReturnVector,n_per_day,ndays,killindex,p,plotflag);

% Compute BV for each day
bv = zeros(ndays,1); rv = zeros(ndays,1);
for t=1:ndays
    r = ReturnVector(((t-1)*n_per_day+1):(t*n_per_day));
    bv(t) = (pi/2) ... 
            * sum(abs(r( 1:(end-1) )) .* abs(r(2:end)) )...
            * n_per_day/(n_per_day-1);
    rv(t) = sum(r.^2);
end

% locate mkt jumps
un = alpha * sqrt(kron(min(bv,rv),tod)) * deltan^0.49;
JN = (abs(ReturnVector) > un);
JI = find(JN);