
% Modified version of Jia's time-of-day routines
function [tod_fit,out] = FAC_tod(ret_all,n,m,killindex,p,plotflag)

ret = reshape(ret_all,n,m);
[tod_fit,out] = tod_sub(ret,killindex,p,plotflag); 

function [tod_fit, output] = tod_sub(ret,killindex,p,plotflag)
n = size(ret,1);
t = (1:n)';

% Set up time polynomial up to order p
tmat = ones(n,p+1);
for j = 1:p
    tmat(:,j+1) = t .^ j;
end

% Delete unwanted data 

% Compute time-of-day effect using bi-power variation
A = ret(:,3:end);
B = ret(:,2:(end-1));
C = ret(:,1:(end-2));
tod_scatter = (1/0.8003)*mean(abs(A).^(2/3).*abs(B).^(2/3).*abs(C).^(2/3),2);
% subset
tod_scatter_tmp = tod_scatter;
tod_scatter_tmp(killindex,:) = [];
tmptmat = tmat;
tmptmat(killindex,:) = [];
 
% Fit a p-polynomial
tod_b = (tmptmat' * tmptmat) \ (tmptmat' * tod_scatter_tmp);
tod_fit = tmat * tod_b;
tod_sav = tod_fit;
%tod_fit(killindex) = mean(tod_scatter(killindex));

% Normalize the fitted
tod_fit = tod_fit./mean(tod_fit);
tod_scatter = tod_scatter./mean(tod_scatter);
tod_sav = tod_sav./mean(tod_sav);
% Output
output.tod_scatter = tod_scatter;
output.tod_fit = tod_fit;
output.tod_b = tod_b;
output.tmat = tmat;
output.tod_sav = tod_sav;
% Plot
if plotflag
    figure;
    plot(tod_scatter,'.')
    hold on;
    plot(tod_fit,'r','linewidth',2)
    title('TOD adjustment, scale factors for TV reallocation')
end


