function [Lhat,Fhat] = jpe_Lhat(X,rbar)
% Input:
% X: X is the N x kn matrix as in the paper ($\hat{X}_n$), for a particular
% window. These are normalized (by sqrt(delta)) *residual* diffusive returns
%
% rbar: is the upper bound of the number of factors
% 
% Output:
% Fhat is kn x rbar, $\hat{F}$ 
% Lhat is N x rbar, $\hat{\Lambda}$

[N,kn] = size(X);
XpX = X' * X;
[V,D] = eig(XpX,'vector');
[junk,I] = sort(D,'descend');
Fhat = sqrt(kn) * V(:,I(1:rbar));
Lhat = X * Fhat / kn;