function jpedata = jpe_makedata(dy,dz,dates,times,JumpIndicator,kn,kmix)
JumpIndicator = JumpIndicator > 0;
JumpIndex = find(JumpIndicator);
T = sum(JumpIndicator); jpedata.T = T;
N = size(dy,2);

Ycont = zeros(N,kn,T);
Zcont = zeros(kn,T);
Yjump = zeros(N,T);
Zjump = zeros(1,T);
Zjump_finescale = zeros(kmix,T);

Jump_Dates = dates(JumpIndicator);
Jump_Times = times(JumpIndicator);

for t = 1:T
    % Loop on all detected jumps
    % The location of this jumps
    eta = JumpIndex(t);

    % Zjump
    Zjump_finescale(:,t) = dz(eta:eta+kmix-1);
    Zjump(t) = sum(dz(eta:eta+kmix-1)); % 1x1

    % Yjump
    % (contructing by summing over the *rows* in the data matrix)
    Yjump(:,t) = sum(dy(eta : eta+kmix-1,:),1)';

    % Z continuous returns 
    Zcont(:,2*t-1) = dz( eta-kn   : eta-1 );
    Zcont(:,2*t)   = dz( eta+kmix : eta+kmix+kn-1 );   

    % Y continuous returns (N x kn)
    Ycont(:,:,2*t - 1) = dy( eta-kn   : eta-1 ,:)';
    Ycont(:,:,2*t) = dy( eta+kmix : eta+kmix+kn-1 ,:)';
end

jpedata.Ycont = Ycont;
jpedata.Zcont = Zcont;
jpedata.Yjump = Yjump;
jpedata.Zjump = Zjump;
jpedata.Zjump_finescale = Zjump_finescale;
jpedata.dates = Jump_Dates';
jpedata.times = Jump_Times';
jpedata.kn = kn;
jpedata.N = N;
jpedata.kmix = kmix;