function newdata = jpe_remove(jpedata,removelist)

if isempty(removelist)
    newdata = jpedata;
    return;
end

if size(removelist,1) * size(removelist,2) ~= length(removelist)
    dates_remove = removelist(:,1);
    times_remove = removelist(:,2);
    n = size(dates_remove,1);
    removeindex = zeros(1,n);
    for i = 1:n
        tmp = find(jpedata.dates == dates_remove(i) & jpedata.times == times_remove(i));
        if ~isempty(tmp)
            removeindex(i) = tmp;
        end
    end
    removeindex(removeindex == 0) = [];
else
    removeindex = removelist(:)';
end

newdata = jpedata;

newdata.T = jpedata.T - length(removeindex);
newdata.Ycont(:,:,[removeindex*2-1 removeindex*2]) = [];
newdata.Zcont(:,[removeindex*2-1 removeindex*2]) = [];
newdata.Yjump(:,removeindex) = [];
newdata.Zjump(removeindex) = [];
newdata.Zjump_finescale(:,removeindex) = [];
newdata.dates(removeindex) = [];
newdata.times(removeindex) = [];
if isfield(newdata,'trunc')
    newdata.trunc(removeindex) = [];
end
